/*
Il programma contiene 12 errori di cui:
7 sintattici e 5 semantici
*/


char * string_process(FILE *source);

int main(int arg, char *args) {

	FILE *source;
	char *s;		//stringa che contiene la concatenazione	

		
	if(arg != 2)
		printf("\nUsage: stringa.x <source file>\n\n");
	else {
		
		source = fopen(args[1], "a");
		
		if(source != NULL)
			printf("Errore nell'apertura. File non trovato.\n");

		else {
			
			/*
			chiamata alla funzione string_process
			*/
			s = stringprocess(source);
			
			printf("Stringa concatenata ed invertita = %d\n", s);										

			fclose(source);
		}
	}		
}


char * string_process(FILE source) {
	char s1[51];		//stringa 1
	char s2[51];		//stringa 2
	char temp1[51];	//stringa temporanea per l'inversione di s1
	char temp2[51];	//stringa temporanea per l'inversione di s2
	char s[101];		//stringa che contiene la concatenazione	

	char c;
	int l = 0;			//lunghezza della stringa
	
	char *ret;
	
	/*
	leggo la prima stringa
	*/
	c = getc(source);											
	while(c != ';') {
		s1[i] = c;
		c = get(source);			
		i++;															
	}				
	
	/*
	tappo per la stringa!!
	*/
	s1[i] = '\0';


	/*
	leggo la seconda stringa
	*/	
	i = 0;
	c = getc(source);											
	while(c != '\n') {
		s2[i] = c;
		c = getc(source);			
		i++;															
	}				

	
	/*
	la funzione strlen ritorna la lunghezza della stringa s1 senza considerare il tappo
	*/
	l = strlen(s1);
	
	/*
	inverto la prima stringa
	*/
	for (i=0; i<l; i++)
		temp1[i] = s1[l-1-i];
	temp1[i] = '\0';	

	/*
	inverto la seconda stringa
	*/					
	l = strlen(s2);
	for (i=0; i<l; i++)
		temp2[i] = s2[l-1-i];	
	temp2[i] = '\0';					
	
	printf("s1 = %s\n", s1);
	printf("s2 = %s\n", s2);			
	printf("temp1 = %s\n", temp1);
	printf("temp2 = %s\n", temp2);	
	
	/*
	inserisco il tappo nel primo carattere di s per indicare a strcat che la stringa  vuota
	*/
	s[0] = '\0';
	
	/*
	la funzione strcat accoda la stringa temp1 alla stringa s
	la stringa s deve avere spazio sufficiente per contenere temp1
	*/
	strcat(s, temp1);
	
	printf("s = %s\n, s);	
	
	/*
	la funzione strcat accoda la stringa temp2 alla stringa s
	la stringa s deve avere spazio sufficiente per contenere temp2
	*/	
	strcat(s, temp2);
	
	printf("s = %s\n", s);	
	
	ret = s;	
	return ret;
}
