#include <stdio.h>

typedef struct record_anag {
		char name[20];
		char last_name[20];
		int age;		
		struct record_anag *next;
	} rec;

rec *registra();
void stampa(FILE *f, rec *lista);

int main(int arg, char *args[]) {

	FILE *dest;
	char c;
	rec *head;
	rec *p;

	if(arg != 2)
		printf("\nUsage: anagrafica.x <filename>\n\n");
	else {
		
		head = registra();		

		p = head;
		
		printf("Un altro record? [s/n]\n");			
	
		do {
			c = getchar();
		} while (c != 's' && c != 'n');
		
		while(c =='s') {
		
			p->next = registra();
			
			p = p->next;
			
			printf("Un altro record? [s/n]\n");			
			
			do {
				c = getchar();
			} while (c != 's' && c != 'n');
		}
		
		dest = fopen(args[1],"w");
		stampa(dest, head);
		printf("Elenco dei record memorizzato nel file %s \n", args[1]);		
		fclose (dest);
	}
	
}

rec *registra() {

		rec *node = (rec *) malloc(sizeof(rec));

		printf("Inserire il nome (max 20 car.)\n");
		scanf("%s", &node->name);
		printf("Inserire il cognome (max 20 car.)\n");
		scanf("%s", &node->last_name);
		printf("Inserire l'eta\n");
		scanf("%d", &node->age);	
		
		node->next = NULL;
	
		return node;

}

void stampa(FILE *f, rec *lista) {

		rec *p;
		
		p = lista;
		
		fprintf(f, "Elenco dei record memorizzati \n");
		fprintf(f, "*******************\n");	
		
		while (p != NULL) {
			fprintf(f,"nome = %s\n", p->name);
			fprintf(f,"cognome = %s\n", p->last_name);
			fprintf(f,"eta' = %d\n", p->age);	
			fprintf(f, "*******************\n");	
			
			p = p->next;
		}
		
		return;
}
