#include <stdio.h>
#include <stdlib.h>

int main(int arg, char *args[]) {


	/*
		Dichiarare tutte le variabili che ritenete necessarie,
		tra cui due variabili per la gestione dei file e un
		puntatore a intero.
		Ricordare inoltre che la variabile che conterra'
		la media deve essere di tipo reale.
	*/

	FILE *source;
	FILE *dest;
	int i, n;
	
	/*
	puntatore ad intero
	*/
	int *value;
	
	float med = 0;
	
	/*
	Controllare che l'utente lanci il programma
	correttamente.
	Lo Usage deve essere: 
	Usage: leggi_file_malloc.x <source file> <destination file>
	Usare argc per capire se il numero di parametri e' corretto.
	Se l'utente non lancia l'esecuzione correttamente
	il programma deve terminare.
	*/
	
	if(arg != 3)
		printf("\nUsage: leggi_file.x <source file> <dest file>\n\n");
	else {
	
		printf("Digitare il numero di elementi contenuti nel file: ");
		scanf("%d", &n);
	
		/*
			Invitare l'utente a digitare il numero di elementi contenuti nel
			file che deve essere letto.
			Memorizzare tale numero in una variabile.
		*/
		
		/*
			Allocare dinamicamente la memoria per la memorizzazione di un
			vettore di interi di dimensione pari al numero indicato precedentemente
			dall'utente. Utilizzare la funzione mallo.
		*/
		value = (int*) malloc(sizeof(int)*n);
		
		/*
			Aprire in lettura il file che contiene i numeri da leggere.
			Controllare che la fopen non ritorni il valore NULL, in ta
			caso l'apertura del file non e' andata a buon fine e
			l'utente deve essere informato.
		*/
		
		source = fopen(args[1], "r");
		
		if(source == NULL)
			printf("Errore nell'apertura. File non trovato.\n");

		else {
			
			/*
				Leggere i numeri contenuti nel file e memorizzarli
				nel vettore precedentemente creato
			*/
			
			for(i=0; i<n; i++) {
				fscanf(source, "%d", value+i);
			}		
			
			fclose(source);
			
			
			/*
				Chiudere il file
			*/
			
			/*
				Calcolare la media dei valori contenuti nel vettore
			*/
			
			for(i=0; i<n; i++)
				med += value[i];
				
			med /= n;				
			
			/* Aprire il file destinazione in scrittura */
			
			dest = fopen(args[2], "w");
			
			/*
				Scrivere nel file gli elementi del vettore uno per riga
				e aggiungere alla fine il valore della media.
			*/
			
			for(i=0; i<n; i++)
				fprintf(dest, "%d\n", *(value+i));
			
				fprintf(dest, "Media = %f\n", med);
			
			/*
				Liberare la memoria allocata per il vettore con la funzione free.
			*/
			
			free(value);
			
			/* Chiudere il file destinazione */
			
			fclose(dest);
	
			/*
				Informare l'utente che tutto e' andato a buon fine e che 
				il risultato si trova nel file indicato nella linea di comando
			*/
			printf("Operazione effettuata. I valori sono stati salvati sul file %s\n\n",args[2]);
		}
	}		
}
